## bees-0.6.5-1.src.tar.gz

=== Makefile ===
PREFIX ?= /usr
ETC_PREFIX ?= /etc
LIBDIR ?= lib

LIB_PREFIX ?= $(PREFIX)/$(LIBDIR)
LIBEXEC_PREFIX ?= $(LIB_PREFIX)/bees

SYSTEMD_SYSTEM_UNIT_DIR ?= $(shell pkg-config systemd --variable=systemdsystemunitdir)

MARKDOWN := $(firstword $(shell type -P markdown markdown2 markdown_py 2>/dev/null || echo markdown))

BEES_VERSION ?= $(shell git describe --always --dirty || echo UNKNOWN)

# allow local configuration to override above variables
-include localconf

DEFAULT_MAKE_TARGET ?= reallyall

ifeq ($(DEFAULT_MAKE_TARGET),reallyall)
	RUN_INSTALL_TESTS = test
endif

include Defines.mk

default: $(DEFAULT_MAKE_TARGET)

all: lib src scripts
docs: README.html
reallyall: all docs test

clean: ## Cleanup
	git clean -dfx -e localconf

.PHONY: lib src test

lib: ## Build libs
	$(MAKE) TAG="$(BEES_VERSION)" -C lib

src: ## Build bins
src: lib
	$(MAKE) BEES_VERSION="$(BEES_VERSION)" -C src

test: ## Run tests
test: lib src
	$(MAKE) -C test

scripts/%: scripts/%.in
	$(TEMPLATE_COMPILER)

scripts: scripts/beesd scripts/beesd@.service

README.html: README.md
	$(MARKDOWN) README.md > README.html.new
	mv -f README.html.new README.html

install_libs: lib
	install -Dm644 lib/libcrucible.so $(DESTDIR)$(LIB_PREFIX)/libcrucible.so

install_tools: ## Install support tools + libs
install_tools: install_libs src
	install -Dm755 bin/fiemap $(DESTDIR)$(PREFIX)/bin/fiemap
	install -Dm755 bin/fiewalk $(DESTDIR)$(PREFIX)/sbin/fiewalk

install_bees: ## Install bees + libs
install_bees: install_libs src $(RUN_INSTALL_TESTS)
	install -Dm755 bin/bees	$(DESTDIR)$(LIBEXEC_PREFIX)/bees

install_scripts: ## Install scipts
install_scripts: scripts
	install -Dm755 scripts/beesd $(DESTDIR)$(PREFIX)/sbin/beesd
	install -Dm644 scripts/beesd.conf.sample $(DESTDIR)/$(ETC_PREFIX)/bees/beesd.conf.sample
ifneq (SYSTEMD_SYSTEM_UNIT_DIR,)
	install -Dm644 scripts/beesd@.service $(DESTDIR)$(SYSTEMD_SYSTEM_UNIT_DIR)/beesd@.service
endif

install: ## Install distribution
install: install_bees install_scripts $(OPTIONAL_INSTALL_TARGETS)

help: ## Show help
	@fgrep -h "##" $(MAKEFILE_LIST) | fgrep -v fgrep | sed -e 's/\\$$//' | sed -e 's/##/\t/'

bees: reallyall
fly: install

=== lib/Makefile ===
TAG ?= $(shell git describe --always --dirty || echo UNKNOWN)

default: libcrucible.so
%.so: Makefile

CRUCIBLE_OBJS = \
	chatter.o \
	cleanup.o \
	crc64.o \
	error.o \
	extentwalker.o \
	fd.o \
	fs.o \
	ntoa.o \
	path.o \
	process.o \
	string.o \
	task.o \
	time.o \
	uuid.o \

include ../makeflags
-include ../localconf
include ../Defines.mk

configure.h: configure.h.in
	$(TEMPLATE_COMPILER)

.depends/%.dep: %.cc configure.h Makefile
	@mkdir -p .depends
	$(CXX) $(CXXFLAGS) -M -MF $@ -MT $(<:.cc=.o) $<

depends.mk: $(CRUCIBLE_OBJS:%.o=.depends/%.dep)
	cat $^ > $@.new
	mv -f $@.new $@

.version.cc: configure.h Makefile ../makeflags $(CRUCIBLE_OBJS:.o=.cc) ../include/crucible/*.h
	echo "namespace crucible { const char *VERSION = \"$(TAG)\"; }" > $@.new
	mv -f $@.new $@

include depends.mk

%.o: %.cc ../makeflags
	$(CXX) $(CXXFLAGS) -fPIC -o $@ -c $<

libcrucible.so: $(CRUCIBLE_OBJS) .version.o
	$(CXX) $(LDFLAGS) -fPIC -shared -Wl,-soname,$@ -o $@ $^ -luuid

=== src/Makefile ===
PROGRAMS = \
	../bin/bees \
	../bin/fiemap \
	../bin/fiewalk \

all: $(PROGRAMS)

include ../makeflags
-include ../localconf

LIBS = -lcrucible -lpthread
LDFLAGS = -L../lib

BEES_OBJS = \
	bees.o \
	bees-context.o \
	bees-hash.o \
	bees-resolve.o \
	bees-roots.o \
	bees-thread.o \
	bees-types.o \

bees-version.c: bees.h $(BEES_OBJS:.o=.cc) Makefile
	echo "const char *BEES_VERSION = \"$(BEES_VERSION)\";" > bees-version.new.c
	mv -f bees-version.new.c bees-version.c

.depends/%.dep: %.cc Makefile
	@mkdir -p .depends
	$(CXX) $(CXXFLAGS) -M -MF $@ -MT $(<:.cc=.o) $<

depends.mk: $(BEES_OBJS:%.o=.depends/%.dep)
	cat $^ > $@.new
	mv -f $@.new $@

include depends.mk

%.o: %.cc %.h
	$(CXX) $(CXXFLAGS) -o $@ -c $<

../bin/%: %.o
	@echo Implicit bin rule "$<" '->' "$@"
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)

../bin/bees: $(BEES_OBJS) bees-version.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)

clean:
	rm -fv *.o bees-version.c

=== test/Makefile ===
PROGRAMS = \
	chatter \
	crc64 \
	fd \
	limits \
	path \
	process \
	progress \
	task \

all: test

test: $(PROGRAMS:%=%.txt) Makefile
FORCE:

include ../makeflags
-include ../localconf

LIBS = -lcrucible -lpthread
LDFLAGS = -L../lib -Wl,-rpath=$(shell realpath ../lib)

.depends/%.dep: %.cc tests.h Makefile
	@mkdir -p .depends
	$(CXX) $(CXXFLAGS) -M -MF $@ -MT $(<:.cc=.o) $<

depends.mk: $(PROGRAMS:%=.depends/%.dep)
	cat $^ > $@.new
	mv -f $@.new $@

include depends.mk

%.o: %.cc %.h ../makeflags Makefile
	@echo "Implicit rule %.o: %.cc"
	$(CXX) $(CXXFLAGS) -o $@ -c $<

$(PROGRAMS): %: %.o ../makeflags Makefile
	@echo "Implicit rule %: %.o"
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)

%.txt: % Makefile FORCE
	./$< >$@ 2>&1 || (RC=$$?; cat $@; exit $$RC)

clean:
	rm -fv $(PROGRAMS:%=%.o) $(PROGRAMS:%=%.txt) $(PROGRAMS)

=== PKGBUILD ===
# Maintainer: Sven-Hendrik Haase <svenstaro@gmail.com>
# Contributor: Gavin Yancey <gyancey@hmc.edu>
# Contributor: Timofey Titovets <nefelim4ag@gmail.com>

pkgname=bees
pkgver=0.6.5
pkgrel=1
pkgdesc="Best-Effort Extent-Same, a btrfs deduplicator daemon"
arch=('x86_64')
url="https://github.com/Zygo/bees"
license=('GPL3')
depends=('util-linux-libs' 'bash')
makedepends=('markdown' 'btrfs-progs' 'systemd')
source=("${pkgname}-${pkgver}.tar.gz"::"https://github.com/Zygo/bees/archive/v${pkgver}.tar.gz")
sha256sums=('f7ab73a6adc48b36bddf408ebc7625770464d8722a134e0fb2fc77e2dbc732b5')

build() {
  cd "${srcdir}/${pkgname}-${pkgver}"
  make BEES_VERSION="${pkgver}"
}

package() {
  cd "${srcdir}/${pkgname}-${pkgver}"

  make install DESTDIR="${pkgdir}" BEES_VERSION="${pkgver}"

  mv "${pkgdir}/usr/sbin" "${pkgdir}/usr/bin"
}
